/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.140 by ce107, Thu Dec 22 01:36:24 2005 UTC revision 1.191 by jmc, Wed Apr 22 19:21:18 2009 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 282  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 321  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 535  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589      -papis | --papis      -papis | --papis
590            Produce summary MFlop/s with PAPI per timestep            Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593      -foolad | --foolad      -foolad | --foolad
594            Fool the AD code generator            Fool the AD code generator
595      -papi | --papi      -papi | --papi
596            Performance analysis with PAPI            Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599      -hpmt | --hpmt      -hpmt | --hpmt
600            Performance analysis with the HPM Toolkit            Performance analysis with the HPM Toolkit
601    
602      -gsl | --gsl      -gsl | --gsl
603            Use GSL to control floating point rounding and precision            Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 556  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -omp | --omp
615              Activate OpenMP code + use Compiler option OMPFLAG
616        -omp=OMPFLAG | --omp=OMPFLAG
617              Activate OpenMP code + use Compiler option OMPFLAG
618    
619        -es | --es | -embed-source | --embed-source
620              Embed a tarball containing the full source code
621              (including the Makefile, etc.) used to build the
622              executable [off by default]
623    
624      -bash NAME      -bash NAME
625            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
626    
# Line 686  void FC_NAMEMANGLE(cloc) ( double *curti Line 751  void FC_NAMEMANGLE(cloc) ( double *curti
751   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
752  }  }
753  EOF  EOF
754      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
755        echo $COMM >> genmake_warnings
756        $COMM >> genmake_warnings 2>&1
757      RET_C=$?      RET_C=$?
758      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
759        program hello        program hello
# Line 696  EOF Line 763  EOF
763        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
764        end        end
765  EOF  EOF
766      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
767        echo $COMM >> genmake_warnings
768        $COMM >> genmake_warnings 2>&1
769      RET_F=$?      RET_F=$?
770      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
771      RETVAL=$?      RETVAL=$?
# Line 709  EOF Line 778  EOF
778    
779    
780  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
781        if test ! "x$HAVE_SIGREG" = x ; then
782            return
783        fi
784      get_fortran_c_namemangling      get_fortran_c_namemangling
785      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
786  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 740  void FC_NAMEMANGLE(sigreg) (int * aip) Line 812  void FC_NAMEMANGLE(sigreg) (int * aip)
812      return;      return;
813  }  }
814  EOF  EOF
815      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
816        echo $COMM >> genmake_warnings
817        $COMM >> genmake_warnings 2>&1
818      RET_C=$?      RET_C=$?
819      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
820        program hello        program hello
# Line 766  EOF Line 840  EOF
840    
841    
842  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
843        if test "x$HAVE_SETRLSTK" = xt ; then
844            DEFINES="$DEFINES -DHAVE_SETRLSTK"
845            return
846        fi  
847        if test ! "x$HAVE_SETRLSTK" = x ; then
848            return
849        fi
850      get_fortran_c_namemangling      get_fortran_c_namemangling
851      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
852  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 781  void FC_NAMEMANGLE(setrlstk) () Line 862  void FC_NAMEMANGLE(setrlstk) ()
862      return;      return;
863  }  }
864  EOF  EOF
865      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
866        echo $COMM >> genmake_warnings
867        $COMM >> genmake_warnings 2>&1
868      RET_C=$?      RET_C=$?
869      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
870        program hello        program hello
# Line 825  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 908  void FC_NAMEMANGLE(tfsize) ( int *nbyte
908          *nbyte = -1;          *nbyte = -1;
909  }  }
910  EOF  EOF
911      make genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
912        echo $COMM >> genmake_warnings
913        $COMM >> genmake_tc.log 2>&1
914      RET_C=$?      RET_C=$?
915      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
916        program hello        program hello
# Line 876  EOF Line 961  EOF
961      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
962      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
963      RET_CPP=f      RET_CPP=f
964      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
965      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
966      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
967      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
968          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
969              >> genmake_tnc.log              >> genmake_tnc.log
# Line 886  EOF Line 971  EOF
971              >> genmake_tnc.log              >> genmake_tnc.log
972      fi      fi
973      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
974      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
975      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
976          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
977      RET_COMPILE=$?      RET_COMPILE=$?
978      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
979    
# Line 904  EOF Line 989  EOF
989      else      else
990          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
991          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
992          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
993          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
994          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
995          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
996              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
997              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
998          RET_COMPILE=$?          RET_COMPILE=$?
999          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
1000          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
1001              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
1002              HAVE_NETCDF=t              HAVE_NETCDF=t
1003            else
1004            # try again with "-lnetcdff" added to the libs
1005                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1006                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1007                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1008                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1009                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
1010                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
1011                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1012                RET_COMPILE=$?
1013                cat genmake_tnc.log >> genmake_warnings
1014                if test "x$RET_COMPILE" = x0 ; then
1015                    LIBS="$LIBS -lnetcdff -lnetcdf"
1016                    HAVE_NETCDF=t
1017                fi
1018          fi          fi
1019      fi      fi
1020      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 950  OPTFILE= Line 1050  OPTFILE=
1050  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1051  FFLAGS=  FFLAGS=
1052  FOPTIM=  FOPTIM=
1053    FEXTRAFLAGS=
1054    USE_EXTENDED_SRC=
1055    EXTENDED_SRC_FLAG=
1056  CFLAGS=  CFLAGS=
1057  KFLAGS1=  KFLAGS1=
1058  KFLAGS2=  KFLAGS2=
# Line 960  NOOPTFILES= Line 1063  NOOPTFILES=
1063  NOOPTFLAGS=  NOOPTFLAGS=
1064  MPI=  MPI=
1065  MPIPATH=  MPIPATH=
1066    OMP=
1067    OMPFLAG=
1068  TS=  TS=
1069  PAPIS=  PAPIS=
1070    PCLS=
1071  FOOLAD=  FOOLAD=
1072  PAPI=  PAPI=
1073    PCL=
1074  HPMT=  HPMT=
1075  GSL=  GSL=
1076    DEVEL=
1077  HAVE_TEST_L=  HAVE_TEST_L=
1078    
1079  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 973  HAVE_SYSTEM= Line 1081  HAVE_SYSTEM=
1081  HAVE_FDATE=  HAVE_FDATE=
1082  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1083  HAVE_CLOC=  HAVE_CLOC=
1084  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1085  HAVE_STAT=  HAVE_STAT=
1086  HAVE_NETCDF=  HAVE_NETCDF=
1087  HAVE_ETIME=  HAVE_ETIME=
# Line 990  BASH= Line 1098  BASH=
1098  PWD=`pwd`  PWD=`pwd`
1099  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1100  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1101    EMBED_SRC=
1102  THISHOST=`hostname`  THISHOST=`hostname`
1103  THISCWD=`pwd`  THISCWD=`pwd`
1104  THISDATE=`date`  THISDATE=`date`
# Line 1023  TAMC_EXTRA= Line 1132  TAMC_EXTRA=
1132    
1133  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1134  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1135  gm_s2="FC CPP IEEE TS PAPIS PAPI HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI OMP DUMPSTATE STANDARDDIRS"
1136    
1137  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1138  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1139  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1140  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1141  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 1053  EOF Line 1162  EOF
1162    
1163  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1164  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1165  printf "  getting local config information:  "  printf "  getting local config information:  "
1166  if test -f $gm_local ; then  if test -f $gm_local ; then
1167      echo "using $gm_local"      echo "using $gm_local"
# Line 1207  for ac_option in "$@" ; do Line 1310  for ac_option in "$@" ; do
1310              TS=true ;;              TS=true ;;
1311          -papis | --papis)          -papis | --papis)
1312              PAPIS=true ;;              PAPIS=true ;;
1313            -pcls | --pcls)
1314                PCLS=true ;;
1315          -foolad | --foolad)          -foolad | --foolad)
1316              FOOLAD=true ;;              FOOLAD=true ;;
1317          -papi | --papi)          -papi | --papi)
1318              PAPI=true ;;              PAPI=true ;;
1319            -pcl | --pcl)
1320                PCL=true ;;
1321          -hpmt | --hpmt)          -hpmt | --hpmt)
1322              HPMT=true ;;              HPMT=true ;;
1323    
1324          -gsl | --gsl)          -gsl | --gsl)
1325              GSL=true ;;              GSL=true ;;
1326    
1327            -devel | --devel)
1328                DEVEL=true ;;
1329    
1330          -mpi | --mpi)          -mpi | --mpi)
1331              MPI=true ;;              MPI=true ;;
1332          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
1333              MPIPATH=$ac_optarg              MPIPATH=$ac_optarg
1334              MPI=true ;;              MPI=true ;;
1335                    
1336  #       -jam | --jam)          -omp | --omp)
1337  #           JAM=1 ;;              OMP=true ;;
1338  #       -nojam | --nojam)          -omp=* | --omp=*)
1339  #           JAM=0 ;;              OMPFLAG=$ac_optarg
1340                OMP=true ;;
1341                    
1342          -ds | --ds)          -ds | --ds)
1343              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 1244  for ac_option in "$@" ; do Line 1355  for ac_option in "$@" ; do
1355          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1356              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1357    
1358            -es | --es | -embed-source | --embed-source)
1359                EMBED_SRC=t ;;
1360    
1361          -*)          -*)
1362              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1363              usage              usage
# Line 1262  done Line 1376  done
1376  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1377      echo      echo
1378      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1379      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1380      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1381      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1382      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1383      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1384      echo      echo
1385  fi  fi
1386    
1387  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1388  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1389      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1390      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1391          ROOTDIR=".."          ROOTDIR=".."
1392      else      else
1393          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1299  if test ! -d ${ROOTDIR} ; then Line 1412  if test ! -d ${ROOTDIR} ; then
1412  fi  fi
1413    
1414  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1415  if test -f "${ROOTDIR}/doc/tag-index" ; then  version_file="${ROOTDIR}/doc/tag-index"
1416      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`  if test -f $version_file ; then
1417        THISVER=`grep '^checkpoint' $version_file | head -1`
1418    #-  remove ./BUILD_INFO.h file if older than version_file
1419        if test -f ./BUILD_INFO.h -a ./BUILD_INFO.h -ot $version_file ; then
1420            echo "  remove ./BUILD_INFO.h (older than ${version_file})"
1421            rm -f ./BUILD_INFO.h
1422        fi
1423  fi  fi
1424    
1425  if test "x$MAKEFILE" = x ; then  if test "x$MAKEFILE" = x ; then
# Line 1456  if test ! "x$MPI" = x ; then Line 1575  if test ! "x$MPI" = x ; then
1575        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1576        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1577  fi  fi
1578    if test ! "x$OMP" = x ; then
1579          echo "  Add OMPFLAG and turn on OpenMP cpp macros"
1580          FFLAGS="$FFLAGS $OMPFLAG"
1581          F90FLAGS="$F90FLAGS $OMPFLAG"
1582          DEFINES="$DEFINES -DUSE_OMP_THREADING"
1583    fi
1584    
1585  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1586        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
# Line 1464  if test ! "x$TS" = x ; then Line 1589  if test ! "x$TS" = x ; then
1589        else        else
1590              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1591        fi        fi
1592          PACKAGES="$PACKAGES showflops"
1593  fi  fi
1594  if test ! "x$PAPIS" = x ; then  if test ! "x$PAPIS" = x ; then
1595        echo "  Turning on PAPI flop summary per timestep"        echo "  Turning on PAPI flop summary per timestep"
# Line 1475  if test ! "x$PAPIS" = x ; then Line 1601  if test ! "x$PAPIS" = x ; then
1601        fi        fi
1602        INCLUDES="$INCLUDES $PAPIINC"        INCLUDES="$INCLUDES $PAPIINC"
1603        LIBS="$LIBS $PAPILIB"        LIBS="$LIBS $PAPILIB"
1604          PACKAGES="$PACKAGES showflops"
1605    fi
1606    if test ! "x$PCLS" = x ; then
1607          echo "  Turning on PCL counter summary per timestep"
1608          echo "  Please make sure PCLINC, PCLLIB are defined"
1609          if test ! "x$FOOLAD" = x ; then
1610                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1611          else
1612                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1613          fi
1614          INCLUDES="$INCLUDES $PCLINC"
1615          LIBS="$LIBS $PCLLIB"
1616          PACKAGES="$PACKAGES showflops"
1617  fi  fi
1618  if test ! "x$PAPI" = x ; then  if test ! "x$PAPI" = x ; then
1619        if test ! "x$PAPIS" = x ; then        if test ! "x$PAPIS" = x ; then
# Line 1488  if test ! "x$PAPI" = x ; then Line 1627  if test ! "x$PAPI" = x ; then
1627            LIBS="$LIBS $PAPILIB"            LIBS="$LIBS $PAPILIB"
1628        fi        fi
1629  fi  fi
1630    if test ! "x$PCL" = x ; then
1631          if test ! "x$PCLS" = x ; then
1632              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1633              echo "  Sticking with PCL flop summary per timestep!"
1634          else
1635              echo "  Turning on performance analysis with PCL"
1636              echo "  Please make sure PCLINC, PCLLIB are defined"
1637              DEFINES="$DEFINES -DUSE_PCL"
1638              INCLUDES="$INCLUDES $PCLINC"
1639              LIBS="$LIBS $PCLLIB"
1640          fi
1641    fi
1642  if test ! "x$HPMT" = x ; then  if test ! "x$HPMT" = x ; then
1643        if test ! "x$PAPI" = x ; then        if test ! "x$PAPI" = x ; then
1644            echo "  PAPI and the HPM Toolkit cannot co-exist!"            echo "  PAPI and the HPM Toolkit cannot co-exist!"
1645            echo "  Sticking with PAPI!"            echo "  Sticking with PAPI!"
1646          else if test ! "x$PCL" = x ; then
1647              echo "  PCL and the HPM Toolkit cannot co-exist!"
1648              echo "  Sticking with PCL!"
1649        else        else
1650            echo "  Turning on performance analysis with the HPM Toolkit"            echo "  Turning on performance analysis with the HPM Toolkit"
1651            echo "  Please make sure HPMTINC, HPMTLIB are defined"            echo "  Please make sure HPMTINC, HPMTLIB are defined"
# Line 1499  if test ! "x$HPMT" = x ; then Line 1653  if test ! "x$HPMT" = x ; then
1653            INCLUDES="$INCLUDES $HPMTINC"            INCLUDES="$INCLUDES $HPMTINC"
1654            LIBS="$LIBS $HPMTLIB"            LIBS="$LIBS $HPMTLIB"
1655        fi        fi
1656          fi
1657  fi  fi
1658  if test ! "x$GSL" = x ; then  if test ! "x$GSL" = x ; then
1659        echo "  Turning on use of GSL to control floating point calculations"        echo "  Turning on use of GSL to control floating point calculations"
# Line 1507  if test ! "x$GSL" = x ; then Line 1662  if test ! "x$GSL" = x ; then
1662        INCLUDES="$INCLUDES $GSLINC"        INCLUDES="$INCLUDES $GSLINC"
1663        LIBS="$LIBS $GSLLIB"        LIBS="$LIBS $GSLLIB"
1664  fi  fi
1665    #- if USE_EXTENDED_SRC is set, add EXTENDED_SRC_FLAG to FFLAGS :
1666    if test ! "x$USE_EXTENDED_SRC" = x ; then
1667          FFLAGS="$FFLAGS $EXTENDED_SRC_FLAG"
1668          F90FIXEDFORMAT="$F90FIXEDFORMAT $EXTENDED_SRC_FLAG"
1669    fi
1670    
1671  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1672  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
# Line 1576  if test "x$HAVE_CLOC" != x ; then Line 1736  if test "x$HAVE_CLOC" != x ; then
1736      echo "yes"      echo "yes"
1737  else  else
1738      echo "no"      echo "no"
1739        if test "x$EMBED_SRC" = xt ; then
1740            echo "    WARNING: you requested file embedding but it has"
1741            echo "      been disabled since C code cannot be called"
1742            EMBED_SRC=
1743        fi
1744  fi  fi
1745  rm -f genmake_t*  rm -f genmake_t*
1746    
1747  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1748  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1749  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1750      echo "yes"      echo "yes"
1751  else  else
1752      echo "no"      echo "no"
# Line 1590  rm -f genmake_t* Line 1755  rm -f genmake_t*
1755    
1756  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1757  check_HAVE_SIGREG  check_HAVE_SIGREG
1758  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1759      echo "yes"      echo "yes"
1760  else  else
1761      echo "no"      echo "no"
# Line 1615  else Line 1780  else
1780  fi  fi
1781  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1782    
1783    if test "x$EMBED_SRC" = xt ; then
1784        build_embed_encode
1785    fi
1786    if test "x$EMBED_SRC" = xt ; then
1787        ENABLE="$ENABLE embed_files"
1788    fi
1789    
1790    
1791  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1792  printf "  Adding MODS directories:  "  printf "  Adding MODS directories: "
1793  for d in $MODS ; do  for d in $MODS ; do
1794      if test ! -d $d ; then      if test ! -d $d ; then
1795          echo          echo
1796          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1797          exit 1          exit 1
1798      else      else
1799          printf " $d"          printf "$d "
1800          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1801          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1802      fi      fi
# Line 1700  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1873  if test -r $ROOTDIR"/eesupp/src/Makefile
1873      fi      fi
1874  fi  fi
1875    
1876  #same for exch2  #same for pkg/exch2 and pkg/regrid
1877  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1878      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1879      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1880      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1881      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1882          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1883      else              rm -f make_${pdir}.errors
1884          echo "Error: problem encountered while building source files in exch2:"          else
1885          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1886          exit 1              cat make_${pdir}.errors 1>&2
1887                exit 1
1888            fi
1889      fi      fi
1890  fi  done
1891    
1892  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1893  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1823  done Line 1998  done
1998  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1999  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
2000    
2001  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
2002  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
2003  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
2004  RETVAL=$?  RETVAL=$?
2005  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1858  EOF Line 2033  EOF
2033      fi      fi
2034  fi  fi
2035    
2036    #  Check for package PROFILES: if NetCDF is not available,
2037    #  then delete profiles from the list of available packages.
2038    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2039    RETVAL=$?
2040    if test "x$RETVAL" = x0 ; then
2041        if test "x$HAVE_NETCDF" != xt ; then
2042            cat <<EOF
2043    
2044    *********************************************************************
2045    WARNING: the "profiles" package was enabled but tests failed to
2046      compile NetCDF applications.  Please check that:
2047    
2048      1) NetCDF is correctly installed for this compiler and
2049      2) the LIBS variable (within the "optfile") specifies the correct
2050           NetCDF library to link against.
2051    
2052      Due to this failure, the "profiles" package is now DISABLED.
2053    *********************************************************************
2054    
2055    EOF
2056            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2057            DISABLE="$DISABLE profiles"
2058        fi
2059    fi
2060    
2061  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2062  ck=  ck=
2063  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2064      i=0      i=0
2065      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2066      rtot=$nname      rtot=$nname
2067      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2068    
2069          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2070          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1898  while test "x$ck" != xtt ; do Line 2098  while test "x$ck" != xtt ; do
2098    
2099          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2100          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2101                #echo "   " $pname ": need to add :" $dname
2102              in_dis="f"              in_dis="f"
2103              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2104                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 2042  fi Line 2243  fi
2243    
2244  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
2245  #  compiler.  #  compiler.
2246  if test -f ./ad_files ; then  if test -f ./adSrcFiles.tmp ; then
2247      rm -f ./ad_files      rm -f ./adSrcFiles.tmp
2248  fi  fi
2249  echo "  Creating the list of files for the adjoint compiler."  echo "  Creating the list of files for the adjoint compiler."
2250  for i in $SOURCEDIRS ; do  for i in $SOURCEDIRS ; do
2251      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2252      for j in $list_files ; do      for j in $list_files ; do
2253          cat $i/$j >> ad_files          cat $i/$j >> adSrcFiles.tmp
2254      done      done
2255  done  done
2256  if test ! "x"$FS = "x.f" ; then  if test ! "x"$FS = "x.f" ; then
2257      cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f      cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2258      mv -f ad_files_f ad_files      mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2259  fi  fi
2260    
2261  echo  echo
# Line 2087  if test ! "x$DIVA" = x ; then Line 2288  if test ! "x$DIVA" = x ; then
2288          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2289      else      else
2290          echo " We cannot create a copy of mpif.h!"          echo " We cannot create a copy of mpif.h!"
2291          exit -1  #       exit -1
2292      fi      fi
2293  fi  fi
2294    
2295  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2296  rm -rf .links.tmp  rm -rf .links.tmp
2297  mkdir .links.tmp  mkdir .links.tmp
2298    touch .links.tmp/foo
2299    if test ! -r ".links.tmp/foo" ; then
2300        echo
2301        echo "ERROR : something is wrong with your directory permissions or"
2302        echo "   your user file-creation mask (\"umask\") since creating a"
2303        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2304        echo "   not working.  Please try setting your umask to something"
2305        echo "   sane such as:"
2306        echo
2307        echo "      umask 0002"
2308        echo
2309        echo "   and please verify that you have the proper permissions for"
2310        echo "   creating sub-directories and then reading files created"
2311        echo "   within them."
2312        echo
2313        exit 1
2314    fi
2315    rm -f .links.tmp/foo
2316    
2317    if test "x$OPENAD" != x ; then
2318        OAD_DONT_COMPILE="/dev/null"
2319        OAD_DONT_TRANSFORM="/dev/null"
2320        OAD_KEEP_ORIGINAL="/dev/null"
2321        OAD_CB2M_FILES="/dev/null"
2322        echo "  looking for dontCompile file:  "
2323        for i in "." $MODS ; do
2324            if test -r $i"/dontCompile" ; then
2325                OAD_DONT_COMPILE=$i"/dontCompile"
2326                echo "     found $OAD_DONT_COMPILE"
2327                break
2328            fi
2329        done
2330        echo "  looking for dontTransform file:  "
2331        for i in "." $MODS ; do
2332            if test -r $i"/dontTransform" ; then
2333                OAD_DONT_TRANSFORM=$i"/dontTransform"
2334                echo "     found $OAD_DONT_TRANSFORM"
2335                break
2336            fi
2337        done
2338        echo "  looking for keepOriginal file:  "
2339        for i in "." $MODS ; do
2340            if test -r $i"/keepOriginal" ; then
2341                OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2342                echo "     found $OAD_KEEP_ORIGINAL"
2343                break
2344            fi
2345        done
2346        echo "  looking for cb2mFiles:  "
2347        for i in "." $MODS ; do
2348            if test -r $i"/cb2mFiles" ; then
2349                OAD_CB2M_FILES=$i"/cb2mFiles"
2350                echo "     found $OAD_CB2M_FILES"
2351                break
2352            fi
2353        done
2354        echo "   OpenAD exceptions:  "
2355    fi
2356    
2357  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2358  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2359  printf 'SRCFILES = '    > srclist.inc  printf 'F77_SRC_FILES = ' > F77srclist.tmp
2360  printf 'CSRCFILES = '   > csrclist.inc  printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2361  printf 'F90SRCFILES = ' > f90srclist.inc  printf 'C_SRC_FILES = '   > csrclist.tmp
2362  printf 'HEADERFILES = ' > hlist.inc  printf 'F90_SRC_FILES = ' > F90srclist.tmp
2363  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'H_SRC_FILES = '   > hsrclist.tmp
2364    printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2365  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2366  for d in $alldirs ; do  for d in $alldirs ; do
2367      deplist=      deplist=
2368      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2369      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2370        if test "x$OPENAD" != x ; then
2371            sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2372        fi
2373      for sf in $sfiles ; do      for sf in $sfiles ; do
2374          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2375              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2376                  ignore_f=f                  ignore_f=f
2377                  case $d/$sf in                  case $d/$sf in
2378                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2379                            ignore_f=t
2380                          ;;                          ;;
2381                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2382                            ignore_f=t
2383                          ;;                          ;;
2384                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2385                            ignore_f=t
2386                          ;;                          ;;
2387                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2388                            ignore_f=t
2389                            ;;
2390                      ./EMBEDDED_FILES.h)
2391                            ignore_f=t
2392                          ;;                          ;;
2393                    *)                    *)
2394                          #  For the local directory *ONLY*,                          #  For the local directory *ONLY*,
# Line 2133  for d in $alldirs ; do Line 2404  for d in $alldirs ; do
2404                  if test "x$ignore_f" = xf ; then                  if test "x$ignore_f" = xf ; then
2405                      extn=`echo $sf | $AWK -F. '{print $NF}'`                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2406                      case $extn in                      case $extn in
2407                          F)                        F)
2408                              echo    " \\"  >> srclist.inc                          echo    " \\"  >> F77srclist.tmp
2409                              printf " $sf" >> srclist.inc                          printf " $sf" >> F77srclist.tmp
2410                              ;;                          if test "x$OPENAD" != x ; then
2411                          F90)                              basename=${sf%%.F}
2412                              echo    " \\"  >> f90srclist.inc                              isAD=`egrep ^$basename.f'[  ]*' adSrcFiles.tmp`
2413                              printf " $sf" >> f90srclist.inc                              if test -z "$isAD" ; then
2414                              ;;                                  toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE}`
2415                          c)                                  if test -z "$toBeIgnored" ; then
2416                              echo    " \\"  >> csrclist.inc                                      echo    " \\"  >> nonADF77srclist.tmp
2417                              printf " $sf" >> csrclist.inc                                      printf " $sf" >> nonADF77srclist.tmp
2418                              ;;                                  else
2419                          h)                                      echo "    not to be compiled   :  $sf"
2420                              echo    " \\"  >> hlist.inc                                  fi
2421                              printf " $sf" >> hlist.inc                              else # file is initially listed as an AD file we want to exclude it
2422                              ;;                                   # or we want to retain the untransformed version
2423                          flow)                                  notToBeTransformed=`egrep ^$basename'[      ]*' ${OAD_DONT_TRANSFORM}`
2424                              echo    " \\"  >> ad_flow_files.inc                                  untransformedVersionToBeKept=`egrep ^$basename'[      ]*' ${OAD_KEEP_ORIGINAL}`
2425                              printf " $sf" >> ad_flow_files.inc                                  if test -n "$notToBeTransformed"; then
2426                              ;;                                      echo "    not to be transformed:  $sf"
2427                      esac                                  fi
2428                  fi                                  if test -n "$untransformedVersionToBeKept" ; then
2429                                        echo "    original to be kept  :  $sf"
2430                                    fi    
2431                                    if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2432                                        echo    " \\"  >> nonADF77srclist.tmp
2433                                        printf " $sf" >> nonADF77srclist.tmp
2434                                    fi
2435                                fi
2436                            fi
2437                            ;;
2438                        F90)
2439                            echo    " \\"  >> F90srclist.tmp
2440                            printf " $sf" >> F90srclist.tmp
2441                            ;;
2442                        c)
2443                            echo    " \\"  >> csrclist.tmp
2444                            printf " $sf" >> csrclist.tmp
2445                            ;;
2446                        h)
2447                            echo    " \\"  >> hsrclist.tmp
2448                            printf " $sf" >> hsrclist.tmp
2449                            ;;
2450                        flow)
2451                            echo    " \\"  >> ad_flow_files.tmp
2452                            printf " $sf" >> ad_flow_files.tmp
2453                            ;;
2454                       esac
2455                    fi
2456              fi              fi
2457          fi          fi
2458      done      done
2459      if test "x$deplist" != x ; then      if test "x$deplist" != x ; then
2460          echo "" >> srclinks.tmp        if test "$d" != "." ; then
2461            echo "" >> srclinks.tmp
2462          echo "#  These files are linked from $d" >> srclinks.tmp          echo "#  These files are linked from $d" >> srclinks.tmp
2463          echo "$deplist :" >> srclinks.tmp          echo "$deplist :" >> srclinks.tmp
2464          printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp  # We need to make sure that the link isn't already there.
2465    # This may happen when make thinks that a header file has to be "remade"
2466    # because a module it depends on has changed.  In this case we do nothing.
2467            printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2468          fi
2469      fi      fi
2470  done  done
2471  rm -rf .links.tmp  rm -rf .links.tmp
2472  echo "" >> srclist.inc  echo "" >> F77srclist.tmp
2473  echo "" >> csrclist.inc  echo "" >> nonADF77srclist.tmp
2474  echo "" >> f90srclist.inc  echo "" >> csrclist.tmp
2475  echo "" >> hlist.inc  echo "" >> F90srclist.tmp
2476  echo "" >> ad_flow_files.inc  echo "" >> hsrclist.tmp
2477    echo "" >> ad_flow_files.tmp
2478    
2479  if test -f $MAKEFILE ; then  if test -f $MAKEFILE ; then
2480      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 2230  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2534  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2534    
2535  # These files are created by Makefile  # These files are created by Makefile
2536  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2537  EOF  EOF
2538    
2539  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2540        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2541    else
2542        echo "EMBEDDED_FILES = " >>$MAKEFILE
2543    fi
2544    
2545  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2546  # Unix ln (link)  # Unix ln (link)
2547  LN = ${LN}  LN = ${LN}
# Line 2261  INCLUDES = ${INCLUDES} Line 2568  INCLUDES = ${INCLUDES}
2568  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2569  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2570  # Optim./debug for FC  # Optim./debug for FC
2571  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2572  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2573  # Optim./debug for FC  # Optim./debug for FC
2574  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
2575  F90OPTIM = ${F90OPTIM}  F90OPTIM = ${F90OPTIM}
2576    F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2577  # Flags for CC  # Flags for CC
2578  CFLAGS = ${CFLAGS}  CFLAGS = ${CFLAGS}
2579  # Files that should not be optimized  # Files that should not be optimized
# Line 2278  MAKEFILE=${MAKEFILE} Line 2586  MAKEFILE=${MAKEFILE}
2586    
2587  EOF  EOF
2588    
2589  cat srclist.inc       >> $MAKEFILE  cat F77srclist.tmp      >> $MAKEFILE
2590  cat csrclist.inc      >> $MAKEFILE  cat nonADF77srclist.tmp >> $MAKEFILE
2591  cat f90srclist.inc    >> $MAKEFILE  cat csrclist.tmp        >> $MAKEFILE
2592  cat hlist.inc         >> $MAKEFILE  cat F90srclist.tmp      >> $MAKEFILE
2593  cat ad_flow_files.inc >> $MAKEFILE  cat hsrclist.tmp        >> $MAKEFILE
2594    cat ad_flow_files.tmp   >> $MAKEFILE
2595    
2596    rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2597    
2598  echo >> $MAKEFILE  echo >> $MAKEFILE
2599  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  
2600  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE  # add definitions for preprocessed sources
2601  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  # and note that not all systems allow case sensitive extensions
2602    # hence the $FS and $FS90 here.
2603    # for fixed format f90 files we use ff90 or FF90 resp
2604    # but these are not expected to be the original source files
2605    
2606    echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')'      >> $MAKEFILE
2607    echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2608    echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2609    echo 'FLOFILES =  $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2610  echo >> $MAKEFILE  echo >> $MAKEFILE
2611  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
2612  echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE  echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  
 rm -f ad_flow_files.inc  
2613    
2614  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2615    
2616  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2617  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2618          @echo Creating \$@ ...          @echo Creating \$@ ...
2619          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2620  depend:  depend:
2621          @make links          @make links
2622          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2623          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2624          -rm -f makedepend.out          -rm -f makedepend.out
2625    
# Line 2309  lib: libmitgcmuv.a Line 2627  lib: libmitgcmuv.a
2627    
2628  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2629          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2630            ar d   libmitgcmuv.a main.o
2631    
2632  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2633    
2634  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2635    
2636  output.txt: \$(EXECUTABLE)  output.txt: \$(EXECUTABLE)
2637          @printf 'running ... '          @printf 'running ... '
2638          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2639    
2640  clean:  clean:
2641          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2642            -rm -rf *.o
2643            -rm -rf *.$FS *.flowdir
2644            -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2645            -rm -rf temp.sed
2646  Clean:  Clean:
2647          @make clean          @make clean
2648          @make cleanlinks          @make cleanlinks
2649          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2650          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2651            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2652  CLEAN:  CLEAN:
2653          @make Clean          @make Clean
2654          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2655          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2656          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2657          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2658            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2659            -rm -rf mnc_test_*
2660    
2661  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2662  makefile:  makefile:
# Line 2338  makefile: Line 2664  makefile:
2664  cleanlinks:  cleanlinks:
2665          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2666    
2667  # Special targets (SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are created by make
2668  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2669          @echo Creating \$@ ...          @echo Creating \$@ ...
2670          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 2358  test ! "x$THISUSER" = x && echo "      -echo Line 2684  test ! "x$THISUSER" = x && echo "      -echo
2684  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2685  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2686    
2687    if test "x$EMBED_SRC" = xt ; then
2688        cat >>$MAKEFILE <<EOF
2689    
2690    decode_files.o : EMBEDDED_FILES.h
2691    
2692    ##  \$(F77_PP_SRC_FILES)
2693    all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2694            @echo Creating \$@ ...
2695            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2696            -rm -f all_fF.tar.gz
2697            -gzip all_fF.tar
2698    
2699    EMBEDDED_FILES.h : all_fF.tar.gz
2700            @echo Creating \$@ ...
2701            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2702    
2703    EOF
2704    fi
2705    
2706  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2707    
2708  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2371  cat >>$MAKEFILE <<EOF Line 2716  cat >>$MAKEFILE <<EOF
2716          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2717  .F90.$FS90:  .F90.$FS90:
2718          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2719    .FF90.f$FS90:
2720            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2721  .$FS90.o:  .$FS90.o:
2722          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2723    .f$FS90.o:
2724            cp \$< \$(basename  \$<).f90
2725            \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename  \$<).f90
2726  .c.o:  .c.o:
2727          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2728    .flow.flowdir:
2729            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2730    
2731  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2732  .F.p:  .F.p:
# Line 2382  cat >>$MAKEFILE <<EOF Line 2734  cat >>$MAKEFILE <<EOF
2734  .p.$FS:  .p.$FS:
2735          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2736    
2737    EOF
2738    
2739  #=========================================  #=========================================
2740  #===  Automatic Differentiation Rules  ===  #===  Automatic Differentiation Rules  ===
2741    #===  for TAMC/TAF  ======================
2742    
2743    if test "x$OPENAD" = x ; then
2744    
2745    cat >>$MAKEFILE <<EOF
2746    
2747  TAMC           = ${TAMC}  TAMC           = ${TAMC}
2748  TAF            = ${TAF}  TAF            = ${TAF}
# Line 2398  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2757  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2757  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2758  for i in $ad_vars ; do  for i in $ad_vars ; do
2759      name=$i      name=$i
2760      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2761      eval $t1      eval $t1
2762      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2763      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2764  done  done
2765    
2766  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2767  echo >> $MAKEFILE  echo >> $MAKEFILE
2768  printf "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2769  AD_FILES=`cat ad_files`  AD_FILES=`cat adSrcFiles.tmp`
2770  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2771      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2772      printf " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2773  done  done
2774  echo >> $MAKEFILE  echo >> $MAKEFILE
2775  rm -f ad_files  rm -f adSrcFiles.tmp
2776    
2777  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2778    
2779  # ... AD ...  # ... AD ...
2780  adall: ad_taf  adall: \$(EXE_AD)
2781  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2782  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2783    
2784  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES) \$(AD_FLOW_FILES)
2785          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2786          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2787          -rm -f ad_config.template          -rm -f ad_config.template
2788          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2789          @make \$(AD_FLOW_FILES)          @make \$(FLOFILES)
2790          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS          cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2791    
2792  ad_taf_output.$FS: ad_input_code.$FS  ad_taf_output.$FS: ad_input_code.$FS
2793          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2794            ls -l ad_input_code_ad.$FS
2795          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2796    
2797  adtafonly:  adtafonly:
2798          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2799            ls -l ad_input_code_ad.$FS
2800          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2801    
2802  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2803          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2804    
2805  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2806          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
# Line 2459  ftlall: ftl_taf Line 2820  ftlall: ftl_taf
2820  ftltaf: ftl_taf_output.$FS  ftltaf: ftl_taf_output.$FS
2821  ftltamc: ftl_tamc_output.$FS  ftltamc: ftl_tamc_output.$FS
2822    
2823  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2824          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2825          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2826          -rm -f ftl_config.template          -rm -f ftl_config.template
2827          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2828          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2829          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2830    
2831  ftl_taf_output.$FS: ftl_input_code.$FS  ftl_taf_output.$FS: ftl_input_code.$FS
2832          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2833            ls -l ftl_input_code_ftl.$FS
2834          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2835    
2836  ftltafonly:  ftltafonly:
2837          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2838            ls -l ftl_input_code_ftl.$FS
2839          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2840    
2841  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
# Line 2510  svd_touch: Line 2873  svd_touch:
2873          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2874          -rm -f ftl_config.template          -rm -f ftl_config.template
2875    
2876  #=========================================  EOF
2877    
2878    fi
2879    
2880    #===  for OpenAD  ========================
2881    
2882    if test "x$OPENAD" != x ; then
2883    
2884    # ============ begin OpenAD specific section ==============
2885    
2886    cat >>$MAKEFILE <<EOF
2887    
2888    # all the source files linked from the various locations:
2889    ALL_LINKED_FILES= \
2890    \$(F77_SRC_FILES) \
2891    \$(C_SRC_FILES) \
2892    \$(H_SRC_FILES) \
2893    \$(F90_SRC_FILES) \
2894    \$(SPECIAL_FILES)
2895    
2896    ifndef OPENADROOT
2897      \$(error "Error:  environment variable OPENADROOT not defined!")
2898    endif
2899    
2900    ifndef XAIFSCHEMAROOT
2901      \$(error "Error:  environment variable XAIFSCHEMAROOT not defined!")
2902    endif
2903    
2904    ifndef XAIFBOOSTERROOT
2905      \$(error "Error:  environment variable XAIFBOOSTERROOT not defined!")
2906    endif
2907    
2908  EOF  EOF
2909    
2910    echo "  Add the source list for common block to module conversion "
2911    echo >> $MAKEFILE
2912    printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2913    for i in `cat ${OAD_CB2M_FILES}` ; do
2914      echo    " \\" >> $MAKEFILE
2915      printf " $i" >> $MAKEFILE
2916    done
2917    echo >> $MAKEFILE
2918    
2919    echo "  Add the source list for AD code generation"
2920    echo >> $MAKEFILE
2921    printf "AD_FILES = " >> $MAKEFILE
2922    for i in `cat ${OAD_CB2M_FILES}` ; do
2923      echo    " \\" >> $MAKEFILE
2924      printf " ${i}_mod.f$FS90" >> $MAKEFILE
2925    done
2926    AD_FILES=`cat adSrcFiles.tmp`
2927    for i in $AD_FILES ; do
2928      basename=${i%%.f}
2929      toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2930      if test -z "$toBeIgnored" ; then
2931        echo    " \\" >> $MAKEFILE
2932        printf " $i" >> $MAKEFILE
2933      fi
2934    done
2935    echo >> $MAKEFILE
2936    rm -f adSrcFiles.tmp
2937    
2938    cat >>$MAKEFILE <<EOF
2939    
2940    adAll: \$(EXE_AD)
2941    .PHONY: adAll
2942    
2943    CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2944    
2945    .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2946    
2947    .PHONY: adDepend
2948    adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2949            \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2950            \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2951            -rm -f makedepend.out
2952    
2953    OPENAD_SUPPORT_F90_SRC_FILES = \
2954    w2f__types.F90 \
2955    OAD_active.F90 \
2956    OAD_cp.F90 \
2957    OAD_rev.F90 \
2958    OAD_tape.F90        
2959    
2960    OPENAD_SUPPORT_C_SRC_FILES = \
2961    iaddr.c \
2962    timeRatio.c
2963    
2964    f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2965            cat \$^ > \$@
2966    
2967    f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2968            cat \$^ > \$@
2969    
2970    f95_test.out: f95_test_mods.f90 f95_test.f90
2971            f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
2972            f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
2973    
2974    AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o  ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
2975    
2976    \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
2977            @echo Creating \$@ ...
2978            \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
2979    
2980    # makefile debug rule
2981    openad: ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2982    .PHONY: openad
2983    
2984    # create the module files
2985    %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
2986            ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
2987    
2988    # create the header files
2989    %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
2990            ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
2991    
2992    # change everybody else to use the new module files:
2993    %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
2994            ../OAD_support/cb2mUseModules.bash $< ${MPI}
2995    
2996    # makefile debug rule
2997    small_f: \$(CB2M_F90_PP_SRC_FILES)
2998    .PHONY: small_f
2999    
3000    ad_output.txt: \$(EXE_AD)
3001            @printf 'linking data files ... '
3002            \$(LN) -f ../input_ad/data* ../input_ad/eedata .
3003            \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
3004            @printf 'running ... '
3005            @./\$(EXE_AD) > \$@
3006    
3007    CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
3008    ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
3009            cat \$^ > \$@
3010    
3011    # strip all comments and blanks to reduce
3012    # the file size in order to reduce perl's memory requirements
3013    ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
3014            cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
3015    
3016    # mfef90 preprocessing
3017    # expand statement functions
3018    # expose mfef90 specific substring handling
3019    # add the w2f__types module
3020    ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
3021            ./mfef90 -r8 -z -F -N132 \$<
3022            mv \$<.B \$(basename \$<).B
3023            ./whirl2f -openad \$(basename \$<).B
3024            cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
3025    
3026    # canonicalizer
3027    ad_input_code_sf.w2f.pre.f$FS90: ad_input_code_sf.w2f.f$FS90 preProcess.py
3028            ./preProcess.py -H -S \$< -o \$@
3029    
3030    # F -> WHIRL
3031    # note that the canonicalized version cuts off at col 72
3032    # doing this also for string constants which is ok as long
3033    # as we are in fixed mode and cut of exactly there.
3034    # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3035    # characters respectively.
3036    ad_input_code_sf.w2f.pre.B: ad_input_code_sf.w2f.pre.f$FS90 mfef90
3037            ./mfef90 -r8 -z -F \$<
3038            mv \$<.B \$@
3039    
3040    # WHIRL -> XAIF
3041    ad_input_code_sf.w2f.pre.xaif : ad_input_code_sf.w2f.pre.B whirl2xaif
3042            ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3043    
3044    # XAIF -> XAIF'
3045    ad_input_code_sf.w2f.pre.xb.xaif : ad_input_code_sf.w2f.pre.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd oadDriver
3046            ./oadDriver -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3047    
3048    # XAIF' -> WHIRL'
3049    ad_input_code_sf.w2f.pre.xb.x2w.B : ad_input_code_sf.w2f.pre.xb.xaif xaif2whirl
3050            ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.pre.B \$<
3051    
3052    # WHIRL' -> F'
3053    ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.B whirl2f whirl2f_be
3054            ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3055    
3056    # insert template directives
3057    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90 ../OAD_support/insertTemplateDir.bash
3058            ../OAD_support/insertTemplateDir.bash \$< \$@
3059    
3060    PPEXTRAS=\$(wildcard ../OAD_support/ad_template.*.F) ../OAD_support/ad_inline.F
3061    # postprocess F'
3062    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90 postProcess.py \$(PPEXTRAS:.F=.f)
3063            ./postProcess.py -m r -i ../OAD_support/ad_inline.f -o \$@ \$<
3064    
3065    # extract all transformed modules
3066    all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3067            cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3068    
3069    # remove the transformed globals module from the
3070    # transformed ad_input_code file
3071    # and remove for now the duplicate variables
3072    # and fix 2 data statements
3073    ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3074            cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^      INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3075    
3076    # setup some links
3077    %.xsd:
3078            \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3079    
3080    mfef90:
3081            \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3082    
3083    # link the support files:
3084    \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3085            \$(LN) ../OAD_support/\$@ .
3086    
3087    whirl2xaif xaif2whirl:
3088            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3089    
3090    preProcess.py postProcess.py:
3091            \$(LN) \${OPENADFORTTK_BASE}/tools/SourceProcessing/\$@ .
3092    
3093    whirl2f whirl2f_be:
3094            \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3095    
3096    oadDriver:
3097            \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/driver/oadDriver \$@
3098    
3099    # ============ end OpenAD specific section ==============
3100    
3101    EOF
3102    
3103    fi
3104    
3105    #=========================================
3106    
3107  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
3108      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3109  fi  fi

Legend:
Removed from v.1.140  
changed lines
  Added in v.1.191

  ViewVC Help
Powered by ViewVC 1.1.22